#include <bits/stdc++.h>

using namespace std;
int n,k,x;
bool rekurzijaprim(int koliko,int brParova,int trenutni)
{

    if(brParova==k && koliko==n )return 1;else
        if(brParova>=k || koliko>=n)return 0;else
    {
        for(int i=1;i<=x;i++)
        {


            if(rekurzijaprim(koliko+i,koliko*i+brParova,i+trenutni-1+x+1))return 1;

        }
    }
    return 0;

}
void rekurzija( int koliko,int brParova,int trenutni)
{
    bool m=false;
    if(koliko>=n || brParova>=k)return ;
    for(int i=1;i<=x;i++)
    {

        if(rekurzijaprim(koliko+i,koliko*i+brParova,i+trenutni-1+x+1))
        {

            for(int j=trenutni;j<=i+trenutni-1;j++)
            {

                printf("%d ", j);
            }
            rekurzija(koliko+i,koliko*i+brParova,i+trenutni-1+x+1);
            m=true;
            break;

        }
        if(m==true)break;
    }
    if(m==false)cout<<-1<<endl;
}
int main()
{

      scanf("%d%d%d", &n, &k, &x);
      rekurzija(0,0,1);


     return 0;
}